/*
  Copyright (C) 2010 Julien Jorge

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: julien.jorge@gamned.org
*/
#include <sstream>
#include <iostream>
#include <fstream>
#include <vector>
#include <ctime>
#include <cstdlib>

#include "kp.hpp"

int main(int argc, char* argv[])
{
  if ( argc != 3 )
    std::cerr << argv[0] << " size max_value" << std::endl;
  else
    {
      unsigned int range_max;
      std::size_t n;
      std::istringstream iss(std::string(argv[1]) + ' ' + argv[2]);

      if ( !(iss >> n) )
        std::cerr << argv[1] << " is not a valid size" << std::endl;
      else if ( !(iss >> range_max) )
        std::cerr << argv[2] << " is not a valid value" << std::endl;
      else
        {
          srand( time(NULL) );
          unsigned int sum_w = 0;
          std::ofstream f
            ( (std::string("instance-") + argv[1] + ".txt").c_str() );

          std::vector<kp_item> data;
          data.reserve(n);

          for ( std::size_t i=0; i!=n; ++i )
            {
              data.push_back
                ( kp_item
                  ( (double)rand() / RAND_MAX * range_max + 1,
                    (double)rand() / RAND_MAX * range_max + 1 ) );
              sum_w += data.back().weight;
            }

          f << (sum_w / 2) << '\n';
          for ( std::size_t i=0; i!=data.size(); ++i )
            f << data[i].profit << ' ' << data[i].weight << '\n';
        }
    }

  return 0;
}
