#ifndef __KP_HPP__
#define __KP_HPP__

#include "meta.hpp"

/**
 * \brief Un objet du problme, pour la mta-programmation.
 * \param Profit Le profit associ  l'objet.
 * \param Weight Le poids associ  l'objet.
 */
template<unsigned int Profit, unsigned int Weight>
struct item
{
  static const unsigned int profit = Profit;
  static const unsigned int weight = Weight;
};

/**
 * \brief Un objet du problme, pour programmation classique.
 */
struct kp_item
{
  kp_item( unsigned int p, unsigned int w )
    : profit(p), weight(w)
  { }

  unsigned int profit;
  unsigned int weight;
};

#endif // __KP_HPP__
