#ifndef __META_HPP__
#define __META_HPP__

/*----------------------------------------------------------------------------*/
/* Partie gnrique de la Mta-programmation. */

/**
 * \brief Cette structure effectue un typedef sur l'un des deux types passs en
 *        paramtres, selon la valeur d'un boolen.
 * \param B Le boolen  valuer.
 * \param T1 Le type sur lequel est fait le typedef quand B est vrai.
 * \param T2 Le type sur lequel est fait le typedef quand B est faux.
 */
template<bool B, typename T1, typename T2>
struct if_then_else;

/** \brief Spcialisation pour le cas o le boolen est vrai. */
template<typename T1, typename T2>
struct if_then_else<true, T1, T2>
{
  typedef T1 result;
};

/** \brief Spcialisation pour le cas o le boolen est faux. */
template<typename T1, typename T2>
struct if_then_else<false, T1, T2>
{
  typedef T2 result;
};

/**
 * \brief Cette structure dfinit une constante ayant pour valeur le maximum des
 *        deux valeurs passes en paramtres.
 * \param A La premire valeur.
 * \param B La seconde valeur.
 */
template<unsigned int A, unsigned int B>
struct max_value
{
  static const unsigned int result = (A>B) ? A : B;
};

/**
 * \brief Une liste de types.
 * \param Head Le premier type dans la liste.
 * \param Tail La suite de la liste.
 */
template<typename Head, typename Tail>
struct type_list
{
  typedef Head head;
  typedef Tail tail;
};

/** \brief Un type vide que l'on utilisera pour marquer la fin d'une liste de
    types. */
struct empty_list {};

/**
 * \brief Rcupre le dernier lment d'une liste de types.
 * \param TypeList La liste de types.
 */
template<typename TypeList>
struct last_type;

/** Spcialisation pour le cas o la liste contient un seul lment. */
template<typename Head>
struct last_type< type_list<Head, empty_list> >
{
  typedef Head result;
};

/** Spcialisation pour le cas o la liste contient plus d'un lment. */
template<typename Head, typename Tail>
struct last_type< type_list<Head, Tail> >
{
  typedef typename last_type<Tail>::result result;
};

/** \brief Indique si un entier est strictement infrieur  un autre. */
template<unsigned int A, unsigned int B>
struct is_less
{
  static const bool result = (A<B);
};

/** \brief Indique si deux entiers sont gaux.. */
template<unsigned int A, unsigned int B>
struct is_equal
{
  static const bool result = (A==B);
};

/** \brief Indique si un entier est infrieur ou gal  un autre. */
template<unsigned int A, unsigned int B>
struct is_less_equal
{
  static const bool result = (A<=B);
};


#endif // __META_HPP__
